package fr.univamu.graph;

import fr.univamu.graph.generators.ErdosRenyi;
import fr.univamu.graph.generators.Grid;
import fr.univamu.graph.rootedtrees.RootedTree;
import fr.univamu.graph.rootedtrees.RootedTreeAnalyser;
import fr.univamu.graph.rootedtrees.TreeStats;
import fr.univamu.graph.search.Search;

import java.util.List;


public class Main {

	public static void main(String[] argv) {
//		TreeStats stats = TreeStats.empty();
//		for (int i = 0; i < 100; i++) {
//			UndirectedGraph graph = new ErdosRenyi(20,0.2).graph();
//			Search search = Search.breadthFirstSearch(graph);
//			search.searchFrom(0);
//			if (search.edges().size() != 19) {
//				continue;
//			}
//			RootedTree tree = RootedTree.of(search.edges());
//			stats = stats.add(RootedTreeAnalyser.statsOf(tree));
//		}
//		System.out.println(stats);

		UndirectedGraph graph = new Grid(3,2).graph();
		RootedTree primMinimumSpanningTree = Algorithms.primMST(graph);
		RootedTree aldousBrodeSpanningTree = Algorithms.aldousBroderST(graph);

		System.out.println("\nGRAPH\n" + graph);
		System.out.println("\nADJACENCIES");
		for (List<Edge> list : graph.adjacencies) {
			System.out.println(list);
		}

		System.out.println("\nPRIM'S MINIMUM SPANNING TREE\n" + primMinimumSpanningTree);

		System.out.println("\nALDOUS BRODE'S SPANNING TREE\n" + aldousBrodeSpanningTree);


	}

}
